Index: /palm/trunk/SOURCE/init_grid.f90
===================================================================
--- /palm/trunk/SOURCE/init_grid.f90	(revision 4652)
+++ /palm/trunk/SOURCE/init_grid.f90	(revision 4653)
@@ -2411,5 +2411,5 @@
 !-- Pre-calculate topography top indices (former get_topography_top_index
 !-- function)
-    ALLOCATE( topo_top_ind(nysg:nyng,nxlg:nxrg,0:4) )
+    ALLOCATE( topo_top_ind(nysg:nyng,nxlg:nxrg,0:5) )
 !
 !-- Uppermost topography index on scalar grid
@@ -2437,4 +2437,10 @@
     topo_top_ind(:,:,4) = MAXLOC( MERGE( 1, 0, BTEST( wall_flags_total_0(:,:,:), ibit ) ), DIM=1 ) &
                           - 1
+!
+!-- Uppermost topography index including full-3D geometry
+    ibit = 12
+    DO  k = nzb, nzt+1
+       WHERE( BTEST( wall_flags_total_0(k,:,:), ibit ) )  topo_top_ind(:,:,5) = k
+    ENDDO
 
  END SUBROUTINE set_topo_flags
